unit Demo_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ZipFix;

{$IFDEF VER130} //delphi 5
  {$DEFINE VER130_PLUS}
{$ENDIF}
{$IFDEF VER135} //bcb 5
  {$DEFINE VER130_PLUS}
{$ENDIF}
{$IFDEF VER140} //delphi 6
  {$DEFINE VER130_PLUS}
{$ENDIF}

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    OKCnt, TotalCnt: integer;
    procedure OnZipFileFound(Sender: TObject;
      const Filename: string; FileInfoIsOK: boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.OnZipFileFound(Sender: TObject;
  const Filename: string; FileInfoIsOK: boolean);
var
  s: string;
begin
  inc(TotalCnt);
  if Filename = '' then
    s := '??filename??' else
    s := Filename;
  if FileInfoIsOK then
    s := s+ #9' seems to be OK' else
    s := s+ #9' is corrupted';
  if FileInfoIsOK then inc(OKCnt);
  memo1.lines.add(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  FixedFile: string;
  //InStream: TMemoryStream;
  //OutStream: TFileStream;
begin
  if not OpenDialog1.execute then exit;
  OKCnt := 0;
  TotalCnt := 0;
  FixedFile := changefileext(OpenDialog1.filename, '_fixed.zip');
  Memo1.clear;
  memo1.lines.add('Broken File: '+OpenDialog1.filename);
  memo1.lines.add('Fixed File: '+FixedFile);
  memo1.lines.add('');
  with TZipFix.create(self) do
  try
    OnFileFound := self.OnZipFileFound;
    {$IFDEF VER130_PLUS}
    Execute( OpenDialog1.filename, FixedFile);
    {$ELSE}
    InStream := TMemoryStream.create;
    OutStream := TFileStream.Create(FixedFile, fmCreate);
    try
      Instream.LoadFromFile(OpenDialog1.filename);
      Execute(InStream,OutStream);
    finally
      Instream.free;
      OutStream.free;
    end;
    {$ENDIF}
    //display totals...
    memo1.lines.add('');
    memo1.lines.add(format('%d out of %d files were OK',[OKCnt, TotalCnt]));
  finally
    free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  close;
end;

end.
